diff --git data/snippets.conf data/snippets.conf
index 317119e..87c76ee 100644
--- data/snippets.conf
+++ data/snippets.conf
@@ -19,13 +19,6 @@
 
 # Default is used for all filetypes and keys can be overwritten by [filetype] sections
 [Default]
-if=if (%cursor%)%block_cursor%
-else=else%block_cursor%
-for=for (i = 0; i < %cursor%; i++)%block_cursor%
-while=while (%cursor%)%block_cursor%
-do=do\n{\n\t%cursor%\n} while (%cursor%)\n%cursor%
-switch=switch (%cursor%)%brace_open%case %cursor%:\n\t\t%cursor%\n\t\tbreak;\n\tdefault:\n\t\t%cursor%\n%brace_close%%cursor%
-try=try%block%\ncatch (%cursor%)%block_cursor%
 
 # special keys to be used in other snippets, cannot be used "standalone"
 # can be used by %key%, e.g. %brace_open%
@@ -44,17 +37,59 @@ block_cursor=\n{\n\t%cursor%\n}\n%cursor%
 [Keybindings]
 #for=<Ctrl>7
 
+[C]
+if=if (%cursor%)%block_cursor%
+else=else%block_cursor%
+for=for (i = 0; i < %cursor%; i++)%block_cursor%
+while=while (%cursor%)%block_cursor%
+do=do\n{\n\t%cursor%\n} while (%cursor%)\n%cursor%
+switch=switch (%cursor%)%brace_open%case %cursor%:\n\t\t%cursor%\n\t\tbreak;\n\tdefault:\n\t\t%cursor%\n%brace_close%%cursor%
+
 [C++]
-for=for (int i = 0; i < %cursor%; i++)%brace_open%\n%brace_close%
+if=if (%cursor%)%block_cursor%
+else=else%block_cursor%
+for=for (int i = 0; i < %cursor%; ++i)%block_cursor%
+while=while (%cursor%)%block_cursor%
+do=do\n{\n\t%cursor%\n} while (%cursor%)\n%cursor%
+switch=switch (%cursor%)%brace_open%case %cursor%:\n\t\t%cursor%\n\t\tbreak;\n\tdefault:\n\t\t%cursor%\n%brace_close%%cursor%
+try=try%block%\ncatch (%cursor%)%block_cursor%
+
+[C#]
+if=if (%cursor%)%block_cursor%
+else=else%block_cursor%
+for=for (int i = 0; i < %cursor%; i++)%block_cursor%
+while=while (%cursor%)%block_cursor%
+do=do\n{\n\t%cursor%\n} while (%cursor%)\n%cursor%
+switch=switch (%cursor%)%brace_open%case %cursor%:\n\t\t%cursor%\n\t\tbreak;\n\tdefault:\n\t\t%cursor%\n%brace_close%%cursor%
+try=try%block%\ncatch (%cursor%)%block_cursor%
+
+[D]
+if=if (%cursor%)%block_cursor%
+foreach=foreach (%cursor%)\n{\n\n}
+for=for (int i = 0; i < %cursor%; i++)\n\t
+while=while (%cursor%)%block_cursor%
+do=do %brace_open%\n\t%cursor%\n%brace_close% while ( )\n
+switch=switch (%cursor%)%brace_open%case %cursor%:\n\t\t%cursor%\n\t\tbreak;\n\tdefault:\n\t\t%cursor%\n%brace_close%%cursor%
+try=try%block%\ncatch (%cursor%)%block_cursor%
 
 [Java]
 for=for (int i = 0; i < %cursor%; i++)%brace_open%\n%brace_close%
+if=if (%cursor%)%block_cursor%
+else=else%block_cursor%
+while=while (%cursor%)%block_cursor%
+do=do\n{\n\t%cursor%\n} while (%cursor%)\n%cursor%
+switch=switch (%cursor%)%brace_open%case %cursor%:\n\t\t%cursor%\n\t\tbreak;\n\tdefault:\n\t\t%cursor%\n%brace_close%%cursor%
 
 [PHP]
 for=for ($i = 0; $i < %cursor%; $i++)%brace_open%\n%brace_close%
+if=if (%cursor%)%block_cursor%
+else=else%block_cursor%
+do=do\n{\n\t%cursor%\n} while (%cursor%)\n%cursor%
+while=while (%cursor%)%block_cursor%
+switch=switch (%cursor%)%brace_open%case %cursor%:\n\t\t%cursor%\n\t\tbreak;\n\tdefault:\n\t\t%cursor%\n%brace_close%%cursor%
 
 [Python]
-for=for i in xrange(%cursor%):\n\t
+for=for i in range(%cursor%):\n\t
 if=if %cursor%:\n\t
 elif=elif %cursor%:\n\t
 else=else:\n\t
@@ -68,9 +103,32 @@ class=class %cursor%:\n\t""" Class doc """\n\t\n\tdef __init__ (self):\n\t\t"""
 iferr=iferr%block_cursor%fix%block%
 monitor=monitor%block_cursor%handle%block%
 
-[Haskell]
-# prevent completion of "do"-while-loops in Haskell
-do=
+[Fortran]
+do=do %cursor%\n\t\nend do
+prog=program %cursor%\n\t\nend program
+if=if(%cursor%) then\n\t\nendif
+select=select case (%cursor%)\n\tcase ()\nend selects\n
+imp=implicit none
+mod=module %cursor%\n\t\nend module\n
+func=function %cursor%()\n\timplicit none\nend function\n
+sub=subroutine %cursor%()\n\timplicit none\nend subroutine\n
 
 [HTML]
 table=<table>\n\t<tr>\n\t\t<td>%cursor%</td>\n\t</tr>\n</table>
+
+[LaTeX]
+# document structure:
+chap=\\chapter{%cursor%}\n
+sec=\\section{%cursor%}\n
+subsec=\\subsection{%cursor%}\n
+subsubsec=\\subsubsection{%cursor%}\n
+# environments:
+itemize=\\begin{itemize}\n%ws%\\item %cursor%\n\\end{itemize}\n
+enumerate=\\begin{enumerate}\n%ws%\\item %cursor%\n\\end{enumerate}\n
+description=\\begin{description}\n%ws%\\item %cursor%\n\\end{description}\n
+figure=\\begin{figure}\n\t\\centering\n\t\includegraphics[]{%cursor%}\n\t\\caption{}\n\t\label{fig:}\n\\end{figure}
+center=\\begin{center}\n\t%cursor%\n\\end{center}
+# misc:
+label=\\label{%cursor%}\n
+# math:
+equation=\\begin{equation}\n%cursor%\n\\end{equation}\n